/**********************************************************

Name:       void Time(void)

Description: 	This function calculates time and Date and
		sets the values for the display.		

Input		none			

Output:        SrDigital, multiple

Misc:       

**********************************************************/
void Time(void)
{
Sec++;							//Timer		
if (Sec > 59)
	{
	Sec = 0;
	Min++;
	if (Min > 59)
 	       {
		Min = 0;
	     	Hrs++;
		if (Hrs > 23)
 	      		{
  	     		Hrs = 0;
  	     		Day++;
			if (Day > monthdays[Month-1])
				{
				Day=1;
				Month++;
				if (Month>12)
					{
					Month=1;
					Year++;
					}
				}
    			}
   		}
 	  }
							//Display Calculation
if (ClockStyle == ANALOG)
 	{
  	SecComp = Sec*6;
 	MinComp = Min*6;
 	if (Hrs < 12) HrsComp = (Hrs*30)+(Min/2);
	else HrsComp = ((Hrs-12)*30)+(Min/2);
 	  }
else
 	 {

 	  SrDigitalPtr = &SrDigital[0];

   	 if (Sec < 50)
		{
  	 	CopyData(Hrs);
	   	CopyText(10);
	   	CopyData(Min);
 		CopyText(10);
  	 	CopyData(Sec);
		}

	  else if (Sec < 55)
		{
		for (j=0;j<8;j++) CopyText (Textfeld[j]);
		}

   	  else 
		{
  	 	CopyData(Day);
	   	CopyText(12);
	   	CopyData(Month);
 	  	CopyText(12);
  	 	CopyData(Year);
		}
	
   	 }
} 

/**********************************************************

Name:       void Ticker_interrupt(void)

Description: 	This function is called exactly 61 times
		per second. 
		It calls the Time Function once per second.

Input:         none

Output:        none

Misc:       

**********************************************************/
void Ticker_interrupt(void)
{
static unsigned char Tick;
Tick++;
IrTick++;
if (IrTick > 13)
   	{
   	IrTick=0;
   	Lock = FALSE;
   	}
if (Tick > 61)
   	{
	if (SetLock == TRUE) Time();			//Run Timer when not in set Mode
   	Tick = 0;
   	}
TCNT0 = 0x04; // reload counter
}

/**********************************************************

Name:       void CopyData(int Value)

Description: Copies Numbers into SrDigital

Input:         Value

Output:        SrDigital

Misc:       

**********************************************************/

void CopyData(unsigned char Value)
{
if (Value < 10)
	{
   	for (i=0;i<6;i++) *SrDigitalPtr++ = table[0][i];
   	for (i=0;i<6;i++) *SrDigitalPtr++ = table[Value][i];
   	}
else
   	{
   	for (i=0;i<6;i++) *SrDigitalPtr++ = table[Value/10][i];
   	for (i=0;i<6;i++) *SrDigitalPtr++ = table[Value-((Value/10)*10)][i];
   	}
}

/**********************************************************

Name:       void CopyText(int Pos)

Description: Copies Text into SrDigital

Input:         Position

Output:        SrDigital

Misc:       

**********************************************************/
void CopyText (unsigned char Pos)
{
for (i=0;i<6;i++) *SrDigitalPtr++ = table[Pos][i];
}


/**********************************************************

Name:       void Crossing_interrupt(void)

Description: 	This function is called whenever the hallsensor
		detects a magnetic field. 
		It calculates the rotating Speed.

Input:         none

Output:        Global Variable Adder, WeelPostion = 0

Misc:       

**********************************************************/
void Crossing_interrupt(void)
{
static unsigned int LastCount;
static unsigned int TotalCount;
static unsigned int Adder2;
static int Latch;
static unsigned char Lap;

Latch = TCNT1;
TotalCount = Latch - LastCount;
LastCount = Latch;
DegreeTime = (TotalCount / 364);
if (DegreeTime < DEGREEMAXTIME)		//RPM > 700 ?
	{ 
	Lap++;
	Adder2 += DegreeTime; 
	if (Lap > 250)
   		{
   		Adder = Adder2/Lap;
   		Lap = 0;
   		Adder2 = 0;
   		}
	}			//Adder = AVG (DegreeTime)
WeelPosition = korrektur;
OCR1A= Latch + Adder;
TIFR1 |= 0x80;
Display();
}

/**********************************************************

Name:       void Degre_interrupt(void)

Description: This Function degrees the Display.

Input:         none

Output:        none

Misc:       

**********************************************************/
void Degre_interrupt(void)
{
OCR1A = TCNT1 + Adder;
Display();
}
 
/**********************************************************

Name:       void Display(void)

Description: This function displays the clock.

Input:         multiple

Output:        WeelPosition

Misc:       

**********************************************************/

void Display(void)
{
PORTB = 0x00;

if (ON==FALSE || DegreeTime >= DEGREEMAXTIME) 
	{
	if (SetLock == FALSE) PORTB=0x01;		//Turn LED1 on if motor is off but clock is in Set Mode
	if (WeelPosition < 360) WeelPosition++;
	return;
	}

if (SetLock == FALSE && WeelPosition == 0) PORTB=0x01;	//Turn LED1 on at top position if Clock is in Set Mode

if (ClockStyle == ANALOG)
   	{
   	if (WeelPosition == HrsComp-2) PORTB = 0x40;		//Analog-Display
   	else if (WeelPosition == HrsComp-1) PORTB = 0x60;
   	else if (WeelPosition == HrsComp) PORTB = 0xf0;
   	else if (WeelPosition == HrsComp+1) PORTB = 0x60;
   	else if (WeelPosition == HrsComp+2) PORTB = 0x40;

   	if (WeelPosition == MinComp-2) PORTB = 0x04;
   	else if (WeelPosition == MinComp-1) PORTB = 0x06;
   	else if (WeelPosition == MinComp) PORTB = 0xff;
   	else if (WeelPosition == MinComp+1) PORTB = 0x06;
   	else if (WeelPosition == MinComp+2) PORTB = 0x04;

   	if (WeelPosition == SecComp) PORTB |= 0x07;

   	if ( (WeelPosition == 30) ||
   		(WeelPosition == 60) ||
   		(WeelPosition == 120) ||
   		(WeelPosition == 150) ||
   		(WeelPosition == 210) ||
   		(WeelPosition == 240) ||
   		(WeelPosition == 300) ||
   		(WeelPosition == 330)) PORTB |= 0x01;

   	else if ((WeelPosition == 0) ||
   		(WeelPosition == 90) ||
   		(WeelPosition == 180) ||
   		(WeelPosition == 270)) PORTB |= 0x03;

   	Pos = ((WeelPosition) / 3);

   	if (Pos < 121)
        	{
     		PORTB |= SrAnalog[120-Pos];
     		}
   	}

else							//Digital-Display
	{
	Pos = ((WeelPosition-100) / 3);
   	if (Pos < 49)
        	{
     		PORTB =  SrDigital[48-Pos];
     		}
   	}

if (WeelPosition < 360) WeelPosition++;
}
 
/**********************************************************

Name:       void IR_interrupt(void)

Description:   This routine is called whenever a rising edge (beginning
                of valid IR signal) is received.

                - The data codes are sent using pulse coding.
                - Each packet has 12 bits and a header.
                - The basic time period T = 550us.
                - The header length = 4T (2.2ms)
                - 0 = pulse with length T followed by space of length T.
                - 1 = pulse with length 2T followed by space of length T.
                - The last 5 bits represent the Addess.
                - The first 7 bits represent the command.
                - A packet is transmitted every 25ms while a button is down.

Input:         none     

Output:        Global variable LatchedIrData

Misc:       Sony VCR protocol

**********************************************************/
void IR_interrupt(void)
{

static unsigned int LastCapture;
static unsigned int IrData;
unsigned int PulseWidth=0;
static unsigned char IrPulseCount;

PulseWidth = ICR1 - LastCapture;
LastCapture = ICR1;

if (PulseWidth > 500 || Lock == TRUE || (DegreeTime > DEGREEMAXTIME))		// DegreeTime < DEGREEMAXTIME means Display is rotating at normal speed (>700 RPM)
  	{
   	LatchedIrData = 0;
   	IrPulseCount = 0;
   	IrData = 0;
   	}
else
   	{
   	IrData = IrData >> 1;
   	if (PulseWidth > 350) IrData = IrData | 0x8000;
   	IrPulseCount++;
   	if (IrPulseCount == 12) 
		{
		LatchedIrData = ((IrData >> 4) & 0x00ff);
		Lock=TRUE;
		IrTick=0;
		IrControl();
		}
   	}
} 

/**********************************************************

Name:       void IrControl(void)

Description: Reads LatchedIrData and Controls the program.

Input:        LatchedIrData

Output:        none

Misc:       

**********************************************************/

void IrControl(void)
{
if (ON == TRUE) 									//Display on?
	{
	if (SetLock == FALSE)								//In set mode?
		{
		switch (LatchedIrData)
			{
			case FB_BUTTON_UP: 				//up button
				SetTime(FWD);				//Set mode FWD
				break;
			case FB_BUTTON_DOWN:				//down button
				SetTime(REW);				//Set mode REW
				break;
			case FB_BUTTON_RIGHT:				//right button
				SetCount++;
				SetTime(TRUE);				//Set mode go one right
				break;
			case FB_BUTTON_LEFT:				//left button
				SetCount--;
				SetTime(TRUE);				//Set mode go one left
				break;
			case FB_BUTTON_MIDDLE: 				//middle button
				//sreg = SREG;
				//cli();
				//eeprom_write_block(Textfeld,Textfeld_EEPROM,8);
				//sei();
				//SREG = sreg;
				SetLock = TRUE;				//leave set mode
				break;
			}
		}
	else									//not in set mode?
		{
		switch (LatchedIrData)
			{
			case FB_BUTTON_RIGHT:				//right button
				ClockStyle = ANALOG;			//Switch Clock Style
				break;
			case FB_BUTTON_LEFT:				//left button
				ClockStyle = DIGITAL;			//Switch Clock Style
				break;
			case FB_BUTTON_MIDDLE: 				//middle button
				SetCount = 0;
				SetLock = FALSE;				//enter set mode
				ClockStyle = DIGITAL;
				break;
			case FB_BUTTON_POWER:				//power button
				ON = FALSE;					//Switch Display off
				break;
			}
		}
	}

else if (LatchedIrData == FB_BUTTON_POWER) ON = TRUE;		//Switch Display on

LatchedIrData = 0;
} 

/**********************************************************

Name:       void SetTime(unsigned char Fast)

Description: Sets Date, Time and Text Message.

Input		Fast: 	TRUE - Set Mode
			REW - Time/Date Back
			FWD - Time/Date FWD

Output:        multiple

Misc:       

**********************************************************/
void SetTime(unsigned char Fast)
{

SrDigitalPtr = &SrDigital[0];	

switch (SetCount)
	{
	case 0: 
		if (Fast==FWD && Hrs<23) Hrs++;
		else if (Fast==REW && Hrs>0) Hrs--;
		CopyData(Hrs);
		CopyText(10);
		CopyText(11);
		CopyText(11);
		CopyText(10);
		CopyText(11);
		CopyText(11);
		break;
	case 1: 
		if (Fast==FWD && Min<59) Min++;
		else if (Fast==REW && Min>0) Min--;
		CopyData(Hrs);
		CopyText(10);
		CopyData(Min);
		CopyText(10);
		CopyText(11);
		CopyText(11);
		break;
	case 2: 
		if (Fast==FWD && Sec<59) Sec++;
		else if (Fast==REW && Sec>0) Sec--;
		CopyData(Hrs);
		CopyText(10);
		CopyData(Min);
		CopyText(10);
		CopyData(Sec);
		break;
	case 3: 
		if (Fast==FWD && Day< monthdays[Month-1]) Day++;
		else if (Fast==REW && Day>1) Day--;
		CopyData(Day);
		CopyText(12);
		CopyText(11);
		CopyText(11);
		CopyText(12);
		CopyText(11);
		CopyText(11);
		break;
	case 4: 
		if (Fast==FWD && Month<12) Month++;
		else if (Fast==REW && Month>1) Month--;
		CopyData(Day);
		CopyText(12);
		CopyData(Month);
		CopyText(12);
		CopyText(11);
		CopyText(11);
		break;
	case 5: 
		if (Fast==FWD && Year<99) Year++;
		else if (Fast==REW && Year>1) Year--;
		CopyData(Day);
		CopyText(12);
		CopyData(Month);
		CopyText(12);
		CopyData(Year);
		break;
	case 6: 
		k=Textfeld[0];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[0] = k;
		CopyText(Textfeld[0]);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		break;
	case 7: 
		k=Textfeld[1];;
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[1] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		break;
	case 8: 
		k=Textfeld[2];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[2] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(Textfeld[2]);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		break;
	case 9: 
		k=Textfeld[3];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[3] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(Textfeld[2]);
		CopyText(Textfeld[3]);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		break;
	case 10: 
		k=Textfeld[4];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[4] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(Textfeld[2]);
		CopyText(Textfeld[3]);
		CopyText(Textfeld[4]);
		CopyText(12);
		CopyText(12);
		CopyText(12);
		break;
	case 11: 
		k=Textfeld[5];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[5] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(Textfeld[2]);
		CopyText(Textfeld[3]);
		CopyText(Textfeld[4]);
		CopyText(Textfeld[5]);
		CopyText(12);
		CopyText(12);
		break;
	case 12: 
		k=Textfeld[6];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[6] = k;
		CopyText(Textfeld[0]);
		CopyText(Textfeld[1]);
		CopyText(Textfeld[2]);
		CopyText(Textfeld[3]);
		CopyText(Textfeld[4]);
		CopyText(Textfeld[5]);
		CopyText(Textfeld[6]);
		CopyText(12);
		break;
	case 13: 
		k=Textfeld[7];
		if (Fast==FWD && k<41) k++;
		else if (Fast==REW && k>0) k--;
		Textfeld[7] = k;
		for (j=0;j<8;j++) CopyText (Textfeld[j]);
		break;
	case 14:
		CopyText(11);				//Show Version Number
		CopyText(34);
		CopyText(11);
		CopyText(1);				//Version Number x.xx coded
		CopyText(12);
		CopyText(0);
		CopyText(3);
		CopyText(11);
		break;
	case 15:
		CopyText(11);				//Show FPS
		CopyData(250000/(DegreeTime*360));	// FPS = 250.000 (Timer1 runs at 250 KHz) / (DegreeTime*360)
		CopyText(11);
		CopyText(18);
		CopyText(28);
		CopyText(31);
		CopyText(11);
		break;

	default:
		SetCount=0;				//Clear Display per default
		CopyText(11);
		CopyText(11);
		CopyText(11);
		CopyText(11);
		CopyText(11);
		CopyText(11);
		CopyText(11);
		CopyText(11);
		break;
	}
}
 
