//**************************************
// Clock 16Mhz
//**************************************
#define F_CPU	  16000000
//**************************************
//            I N C L U D E
//**************************************
#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include "Files/Headerfiles/Propelleruhr.h"
#include "Files/Init.c"
#include "Files/Bitmuster.c"
#include "Files/Functions.c"

//**************************************
//            M A I N
//**************************************
int main()
{

//uint8_t sreg;

//cli();

//eeprom_read_block(Textfeld,Textfeld_EEPROM,8);

//CPU Initialisation

WDTCSR = 0x0e;        	// Enable WatchDog at 0.97 sec

PORTD = 0x0c;        	// Pull up on PD2&PD3
DDRD = 0x03;         	// PD0-O PD1-O PD2-I PD3-I PD4-I PD5-I PD6-I PD7-I

//INT 0
EICRA = 0x02;        	// Int0 generate int on falling eadge

EIMSK = 0x01;        	// Int0 enable

//Timer0
TCCR0B = 0x05;        	// Timer0 / 1024 

//Timer1
TCCR1B = 0x43;       	// Timer1 / 64 & Input Capture on Rising eadge

TIMSK1 = 0x22;       	// int enable on Timer1 Compare Match 
                  	// int enable on Timer 1 Input Capture
                  	// int enable on Timer0 Overflow

TIMSK0 = 0x01;

PORTB = 0x00;
DDRB = 0xff;         	// PB0-7 as output

sei();

//Endless loop

while(1)
   {
   asm("WDR");
   }
}









